#pragma once

#include "GeometryNode.h"

class CircleNode : public GeometryNode
{
public:
    CircleNode(const Point& location, double radius);

    Type getType() override;

    double getRadius() const;

    SceneItem* getSceneItem(std::size_t idx) const override;
    std::size_t getNumSceneItems() const override;

    void setMinorRadius(double radius);
    void setRadius(double radius);

    void update(SceneInfo* sceneInfo) override;
private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);
    void updateMaterial();
    double mRadius{1.0};
    double mMinorRadius{ 1.0 };

    std::unique_ptr<SceneModel> mBackgroundItem;
    std::unique_ptr<SceneModel> mOutlineItem;
};
